/* This loader renders the template with underscore if no other loader was found */
'use strict';

var _ = require('lodash');
var loaderUtils = require('loader-utils');
var vm = require('vm')

module.exports = function (source) {
  if (this.cacheable) {
    this.cacheable();
  }
  if (/\.js$/.test(this.resourcePath)) {
    return source;
  }
  var options = this.query?loaderUtils.parseQuery(this.query):{};
  var template = _.template(source, _.defaults(options, { variable: 'data' }));

  var code = 'var _ = lodash;' +
    'module.exports = function (templateParams) {' +
      'return (' + template.source + ')();' +
    '}';
  var sandbox = {
    module:{},
    export:{},
    require:require,
    lodash:_
  }
  vm.runInNewContext(code,sandbox,{
      displayErrors:true
  })
  return sandbox.module.exports()
};
